#
# Compute Dijkstra (link state).
#

set nodes {A B C D E}
set source A
set infty 200

set c(A,A) 0
set c(A,B) 1
set c(A,C) $infty
set c(A,D) 9
set c(A,E) $infty

set c(B,A) 1
set c(B,C) 1
set c(B,D) $infty
set c(B,E) 3

set c(C,A) $infty
set c(C,B) 1
set c(C,D) $infty
set c(C,E) 1

set c(D,A) 9
set c(D,B) $infty
set c(D,C) $infty
set c(D,E) 5

set c(E,A) $infty
set c(E,B) 3
set c(E,C) 1
set c(E,D) 5

proc ldelete {list e} {
  set i [lsearch $list $e]
  if {$i >= 0} {
    set list [lreplace $list $i $i]
  }
  return $list
}

proc min {a b} {
  if {$a < $b} {return $a}
  return $b
}

# start out N = {source}
set N    $source
set left [ldelete $nodes $source]

# initialization
foreach v $nodes {
  if {[info exists c($source,$v)]} {
    set d($v) $c($source,$v)
    set p($v) $source
  } else {
    set d($v) $infty
    set p($v) -
  }
} 

set i 1
while {[llength $left] > 0} {
  # find node w not in N such that d(w) is smallest
  set min $infty
  foreach v $left {
    if {$d($v) < $min} {
      set min $d($v)
      set w $v
    }
  } 
  # add w into N:
  set left [ldelete $left $w]
  lappend N $w

  # update d(v) for all v in N:
  foreach v $left {
    if {[expr $d($w) + $c($w,$v)] < $d($v)} {
      set d($v) [expr $d($w) + $c($w,$v)]
      set p($v) $w
    }
  }
  puts -nonewline "$i: N={$N} "
  foreach v $nodes {
    puts -nonewline "$v=$d($v),$p($v) "
  }
  puts ""
  incr i
}
