#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
  int s = -1, t = -1;
  int n;
  struct sockaddr_in sin;
  char msg[80];
  fd_set rfds;
  int sinlen;
  struct timeval tv;

  if (argc < 2) { printf("%s port\n", argv[0]); return -1; }

  if ((s = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket"); return -1;
  }
  sin.sin_family      = AF_INET;
  sin.sin_port        = htons(atoi(argv[1]));
  sin.sin_addr.s_addr = INADDR_ANY;
  if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
    perror("bind"); return -1;
  }
  if (listen(s, 5) < 0) { perror("listen"); return -1; }
  tv.tv_sec = 10;
  tv.tv_usec = 0;
  while (1) {
    FD_ZERO(&rfds);
    if (s > 0) FD_SET(s, &rfds);
    if (t > 0) FD_SET(t, &rfds);
    n = select(64, &rfds, NULL, NULL, &tv);
    if (n == 0) { printf("Timeout!\n"); }
    else if (n > 0) {
      if (s > 0 && FD_ISSET(s, &rfds)) {
        sinlen = sizeof(sin);
        if ((t = accept(s, (struct sockaddr *)&sin, &sinlen)) < 0) {
          perror("accept"); return -1;
        }
        printf("From %s:%d.\n", 
          inet_ntoa(sin.sin_addr), ntohs(sin.sin_port));
      }
      if (t > 0 && FD_ISSET(t, &rfds)) {
        if ((n=read(t,msg,sizeof(msg))) < 0) {perror("read"); return -1;}
        if (n == 0) { close(t); t = -1; }
        else {
          if (write(t,msg,n)<0) {perror("write");return -1;}
        }
      }
    }
  }
  if (close(t) < 0) { perror("close"); return -1; }
  if (close(s) < 0) { perror("close"); return -1; }
  return 0;
}
